<?php
# PHP guestbook (GBook) - MULTILINGUAL
# BASED ON Version: 1.43
# File last modified: July 26 2006 18:11
# File name: gbook.php
# Written 27th December 2004 by Klemen Stirn (info@phpjunkyard.com)
# http://www.PHPJunkYard.com
#
# multilingual version October 28, 2006, by Frank Hoek
# http://www.frankma.nl
# gbook@frankma.nl

##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2004-2006 PHPJunkyard All Rights Reserved.                       #
#                                                                            #
# This script may be used and modified free of charge by anyone so long as   #
# this copyright notice and the comments above remain intact. By using this  #
# code you agree to indemnify Klemen Stirn from any liability that might     #
# arise from it's use.                                                       #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden. In other words, please ask first before you try and   #
# make money off this program.                                               #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium. In all cases copyright and header must remain intact. #
# This Copyright is in full effect in any country that has International     #
# Trade Agreements with the United States of America or with                 #
# the European Union.                                                        #
##############################################################################

#############################
#     DO NOT EDIT BELOW     #
#############################
error_reporting(E_ALL ^ E_NOTICE);
define('IN_SCRIPT',true);

require_once('settings.php');
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
$settings['verzija']='1.43';

$a=htmlspecialchars($_REQUEST['a']);

/* And this will start session which will help prevent multiple submissions and spam */
if($a=='sign' || $a=='add') {
    session_start();
	if ($settings['autosubmit'] && $a!='add')
	{
	    $_SESSION['secnum']=rand(10000,99999);
	    $_SESSION['checksum']=crypt($_SESSION['secnum'],$settings['filter_sum']);
	}
    session_regenerate_id();
}

printNoCache();
printTopHTML();

if (!(empty($a))) {

	if (!empty($_SESSION['block'])) {
        problem($lang_problem01,0);
    }

    if($a=='sign') {
        printSign();
    } elseif($a=='delete') {
        $num=gbook_isNumber($_GET['num'],$lang_invalid_id);
        confirmDelete($num);
    } elseif($a=='viewprivate') {
        $num=gbook_isNumber($_GET['num'],$lang_invalid_id);
        confirmViewPrivate($num);
    } elseif($a=='add') {

        $name=gbook_input($_POST['name']);
        $from=gbook_input($_POST['from']);
        $a=check_mail_url(); $email=$a['email']; $url=$a['url'];
        $comments=gbook_input($_POST['comments']);
        $isprivate=gbook_input($_POST['private']);

        if ($isprivate) {$sign_isprivate='checked';}
        if ($_REQUEST['nosmileys']) {$sign_nosmileys='checked';}

        if (empty($name))
        {
            printSign($name,$from,$email,$url,$comments,$sign_nosmileys,$sign_isprivate,$lang_enter_name);
        }
        if ($email=='INVALID')
        {
            printSign($name,$from,'',$url,$comments,$sign_nosmileys,$sign_isprivate,$lang_enter_email);
        }
        if ($url=='INVALID')
        {
            printSign($name,$from,$email,'',$comments,$sign_nosmileys,$sign_isprivate,$lang_enter_url);
        }
        if (empty($comments))
        {
            printSign($name,$from,$email,$url,$comments,$sign_nosmileys,$sign_isprivate,$lang_enter_comments);
        }

        /* Use security image to prevent automated SPAM submissions? */
        if ($settings['autosubmit'])
        {
        	$mysecnum=gbook_isNumber($_POST['mysecnum']);
	        if (empty($mysecnum))
	        {
	            printSign($name,$from,$email,$url,$comments,$sign_nosmileys,$sign_isprivate,$lang_enter_secnum);
	        }
	        require('SecImg.inc.php');
	        $sc=new PJ_SecurityImage($settings['filter_sum']);
	        if (!($sc->checkCode($mysecnum,$_SESSION['checksum']))) {
	            printSign($name,$from,$email,$url,$comments,$sign_nosmileys,$sign_isprivate,$lang_wrong_secnum);
            }
        }

        /* Check the message with JunkMark(tm)? */
        if ($settings['junkmark_use'])
        {
            $junk_mark=JunkMark($email,$url,$comments);

            if ($junk_mark >= $settings['junkmark_limit'])
            {
            	$_SESSION['block'] = 1;
                problem($lang_problem01,0);
            }
        }

        addEntry($name,$from,$email,$url,$comments,$isprivate);

    } elseif($a=='confirmdelete') {
        $pass=gbook_input($_REQUEST['pass'],$lang_enter_password);
        $num=gbook_isNumber($_REQUEST['num'],$lang_invalid_id);
        doDelete($pass,$num);
    } elseif($a=='showprivate') {
        $pass=gbook_input($_REQUEST['pass'],$lang_enter_password);
        $num=gbook_isNumber($_REQUEST['num'],$lang_invalid_id);
        showPrivate($pass,$num);
    }  elseif($a=='reply') {
        $num=gbook_isNumber($_REQUEST['num'],$lang_invalid_id);
        writeReply($num);
    }  elseif($a=='postreply') {
        $pass=gbook_input($_REQUEST['pass'],$lang_enter_password);
        $comments=gbook_input($_REQUEST['comments'],$lang_enter_reply);
        $num=gbook_isNumber($_REQUEST['num'],$lang_invalid_id);
        postReply($pass,$num,$comments);
    } elseif($a=='viewIP') {
        $num=gbook_isNumber($_REQUEST['num'],$lang_invalid_id);
        confViewIP($num);
    } elseif($a=='seeIP') {
        $pass=gbook_input($_REQUEST['pass'],$lang_enter_password);
        $num=gbook_isNumber($_REQUEST['num'],$lang_invalid_id);
        seeIP($pass,$num);
    } else {
        problem($lang_problem02);
    }
}

$page=gbook_isNumber($_REQUEST['page']);
if ($page>0) {
	$start=($page*10)-9;$end=$start+9;
} else {
	$page=1;$start=1;$end=10;
}

$lines=file($settings['logfile']);
$total = count($lines);

if ($total > 0) {
	if ($end > $total) {$end=$total;}
    $pages = ceil($total/10);

    $prev_page = ($page-1 <= 0) ? 0 : $page-1;
    $next_page = ($page+1 > $pages) ? 0 : $page+1;

    echo '<p>'.$lang_sentence01a.$total.$lang_sentence01b.$pages.$lang_sentence01c.'<br>';

    $gbook_nav = '';

    if ($prev_page) {
        $gbook_nav .= '
        <a href="gbook.php?page=1">&lt;&lt; '.$lang_first.'</a>
        &nbsp;|&nbsp;
        <a href="gbook.php?page='.$prev_page.'">&lt; '.$lang_previous.'</a>
        &nbsp;|&nbsp;
        ';
    }

    for ($i=1; $i<=$pages; $i++) {
        if ($i <= ($page+5) && $i >= ($page-5)) {
           if($i == $page) {$gbook_nav .= ' <b>'.$i.'</b> ';}
           else {$gbook_nav .= ' <a href="gbook.php?page='.$i.'">'.$i.'</a> ';}
        }
    }

    if ($next_page) {
        $gbook_nav .= '
        &nbsp;|&nbsp;
        <a href="gbook.php?page='.$next_page.'">'.$lang_next.' &gt;</a>
        &nbsp;|&nbsp;
        <a href="gbook.php?page='.$pages.'">'.$lang_last.' &gt;&gt;</a>
        ';
    }

    echo $gbook_nav;
}

echo '</p>
<table border="0" cellspacing="0" cellpadding="2" width="95%" class="entries">';

if ($total == 0) {
	echo '
    <tr>
        <td>'.$lang_no_entries.'</td>
    </tr>
    ';
}
else {printEntries($lines,$start,$end);}

echo '</table>';

if ($total > 0) {
	echo '<p>'.$gbook_nav.'</p>';
}

printDownHTML();
exit();


// >>> START FUNCTIONS <<< //

function seeIP($pass,$num) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
if ($pass != $settings[apass]) {problem($lang_problem03);}
$lines=file($settings['logfile']);
$myline=explode("\t",$lines[$num]);
if (empty($myline[8])) {$ip=$lang_ip_inavailable;}
else
{
	$ip=rtrim($myline[8]);
    $host=@gethostbyaddr($ip);
    if ($host && $host!=$fp) {$ip.=' ('.$host.')';}
}
?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p><?php echo $lang_post_submitted_from; ?> <b><?php echo $ip; ?></b></p>
<p><a href="gbook.php?page=1"><? echo $lang_click_here; ?></a></p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END seeIP

function confViewIP($num) {
global $settings;    //  link to  -  FMH
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<form action="gbook.php" method="POST"><input type="hidden" name="a" value="seeIP">
<input type="hidden" name="num" value="<?php echo($num); ?>">
<p><b><? echo $lang_restricted_access_view_ip; ?></b></p>
<p><? echo $lang_enter_password; ?><br>
<input type="password" name="pass" size="20"></p>
<p><input type="submit" value="View IP"> | <a href="Javascript:history.go(-1)"><? echo $lang_back; ?></a></p>
</form>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END confViewIP

function postReply($pass,$num,$comments) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH

if ($pass != $settings[apass]) {problem($lang_problem03);}

$comments = str_replace("\r\n","<br>",$comments);
$comments = str_replace("\n","<br>",$comments);
$comments = str_replace("\r","<br>",$comments);
$comments = wordwrap($comments,$settings['max_word'],' ',1);
if ($settings['smileys'] == 1 && $_REQUEST['nosmileys'] != 'Y') {$comments = processsmileys($comments);}
if ($settings['filter']) {$comments = filter_bad_words($comments);}

$myline=array(0=>'',1=>'',2=>'',3=>'',4=>'',5=>'',6=>'',7=>'',8=>'');
$lines=file($settings['logfile']);
$myline=explode("\t",$lines[$num]);
foreach ($myline as $k=>$v) {
	$myline[$k]=rtrim($v);
}
$myline[7]=$comments;
$lines[$num]=implode("\t",$myline)."\n";
$lines=implode('',$lines);
$fp = fopen($settings['logfile'],'wb') or problem($lang_problem04a.$settings[logfile].$lang_problem04b);
fputs($fp,$lines);
fclose($fp);
?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p><b><? echo $lang_reply_posted; ?></b></p>
<p><a href="gbook.php?page=1"><? echo $lang_click_here; ?></a></p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END postReply

function writeReply($num) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<form action="gbook.php" method="POST" name="form"><input type="hidden" name="a" value="postreply">
<input type="hidden" name="num" value="<?php echo($num); ?>">
<p><? echo $lang_restricted_access_write_reply; ?></p>
<p><b><? echo $lang_enter_password; ?></b><br>
<input type="password" name="pass" size="20"></p>
<p align="center"><b><? echo $lang_your_message; ?></b><br>
<textarea name="comments" rows="9" cols="50"></textarea>
<?php
if ($settings['smileys']) {
	echo '
	<br><a href="javascript:openSmiley()">'.$lang_insert_smiley.'</a>'.$lang_open_window.'<br>
	<input type="checkbox" name="nosmileys" value="Y">'.$lang_disable_smiley;
}
?></p>
<p><input type="submit" value="<? echo $lang_add_reply; ?>"> | <a href="Javascript:history.go(-1)"><? echo $lang_back; ?></a></p>
</form>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END writeReply


function check_secnum($secnumber,$checksum) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
$secnumber.=$settings['filter_sum'].date('dmy');
    if ($secnumber == $checksum)
    {
        unset($_SESSION['checked']);
        return true;
    }
    else
    {
        return false;
    }
} // END check_secnum


function print_secimg($name,$from,$email,$url,$comments,$isprivate,$message=0) {
global $settings;
$_SESSION['checked']=$settings['filter_sum'];
?>
<h3 align="center"><? echo $lang_anti_spam; ?></h3>
</p>
<form action="gbook.php?<?php echo strip_tags(SID);?>" method="POST" name="form"><input type="hidden" name="a" value="add">
<table class="entries" cellspacing="0" cellpadding="4" border="0">
<tr>
<td>

<p>&nbsp;</p>
<?php
if ($message == 1) {echo '<p align="center"><b>'.$lang_enter_secnum.'</b></p>';}
elseif ($message == 2) {echo '<p align="center"><b>'.$lang_wrong_secnum.'</b></p>';}
?>
<p>&nbsp;</p>
<p><? echo $lang_secnum_explanation; ?></p>
<p>&nbsp;</p>
<p>Security number: <b><?php echo $_SESSION['secnum']; ?></b><br><? echo $lang_enter_secnum; ?>
<input type="text" size="7" name="secnumber" maxlength="5" id="input"></p>
<p>&nbsp;
<input type="hidden" name="name" value="<?php echo $name; ?>">
<input type="hidden" name="from" value="<?php echo $from; ?>">
<input type="hidden" name="email" value="<?php echo $email; ?>">
<input type="hidden" name="url" value="<?php echo $url; ?>">
<input type="hidden" name="comments" value="<?php echo $comments; ?>">
<input type="hidden" name="private" value="<?php echo $isprivate; ?>">
<input type="hidden" name="nosmileys" value="<?php echo $_REQUEST['nosmileys']; ?>">
</p>
<p align="center"><input type="submit" value="<?php echo $lang_continue; ?>"></p>
<p>&nbsp;</p>
<p>&nbsp;</p>
</td>
</tr>
</table>
</form>

<?php
printDownHTML();
exit();
} // END print_secimg

function filter_bad_words($text) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
$file = 'badwords/'.$settings['filter_lang'].'.php';

	if (file_exists($file))
    {
        include_once($file);
    }
    else
    {
        problem($lang_problem05a.$file.$lang_problem05b);
    }

    foreach ($settings['badwords'] as $k => $v)
    {
        $text = preg_replace("/\b$k\b/i",$v,$text);
    }

return $text;
} // END filter_bad_words

function showPrivate($pass,$num) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
if ($pass != $settings[apass]) {problem($lang_problem06);}

$delimiter="\t";
$lines=file($settings['logfile']);
list($name,$from,$email,$url,$comment,$added,$isprivate,$reply)=explode($delimiter,$lines[$num]);

echo '
<table border="0" cellspacing="0" cellpadding="2" width="95%" class="entries">
<tr>
<td class="upper" width="35%"><b>'.$lang_submitted_by.'</b></td>
<td class="upper" width="65%"><b>'.$lang_comments.'</b></td>
</tr>
<tr>
<td valign="top" width="35%">'.$lang_name.'<b>'.$name.'</b><br>
';
if ($from)
{
	echo '<font class="smaller">'.$lang_from.$from.'</font><br>';
}
if ($settings['use_url'] && $url)
{
	echo '<font class="smaller">'.$lang_website.'</font> <a href="go.php?url='.$url.'" target="_blank" class="smaller">'.$url.'</a><br>';
}
if ($email)
{
	echo '<font class="smaller">'.$lang_email.'</font> <a href="mailto&#58;'.$email.'" target="_blank" class="smaller">'.$email.'</a>';
}

echo '
</td>
<td valign="top" width="65%">
'.$comment;

    if (!empty($reply)) {
        echo '<p><i><b>'.$lang_admin_reply.'</b> '.$reply.'</i>';
    }

echo '<hr>
<table border="0" width="100%" cellspacing="0" cellpadding="0">
<tr>
<td width="50%" align="left"><font class="smaller">'.$lang_added.$added.'</font></td>
<td width="50%" align="right">
<a href="gbook.php?a=delete&amp;num='.$num.'"><img src="images/delete.gif" width="14" height="14" border="0" alt="'.$lang_delete_entry.'" title="'.$lang_delete_entry.'"></a>
&nbsp;<a href="gbook.php?a=reply&amp;num='.$num.'"><img src="images/reply.gif" width="14" height="14" border="0" alt="'.$lang_reply_to_entry.'" title="'.$lang_reply_to_entry.'"></a>
&nbsp;<a href="gbook.php?a=viewIP&amp;num='.$num.'"><img src="images/ip.gif" width="14" height="14" border="0" alt="'.$lang_view_ip_address.'" title="'.$lang_view_ip_address.'"></a>
&nbsp;
</td>
</tr>
</table>

</td>
</tr>
</table>
<p align="center"><a href="gbook.php">'.$lang_back_to_book.'</a></p>
';

printDownHTML();
exit();
} // END showPrivate

function confirmViewPrivate($num) {
global $settings;    //  link to  -  FMH
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<form action="gbook.php" method="POST"><input type="hidden" name="a" value="showprivate">
<input type="hidden" name="num" value="<?php echo($num); ?>">
<p><b><? echo $lang_private_post; ?></b></p>
<p><? echo $lang_enter_password; ?><br>
<input type="password" name="pass" size="20"></p>
<p><input type="submit" value="<? echo $lang_view_entry; ?>"> | <a href="Javascript:history.go(-1)"><? echo $lang_back; ?></a></p>
</form>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END confirmViewPrivate

function processsmileys($text) {
$text = str_replace(':)','<img src="images/icon_smile.gif" border="0" alt="">',$text);
$text = str_replace(':(','<img src="images/icon_frown.gif" border="0" alt="">',$text);
$text = str_replace(':D','<img src="images/icon_biggrin.gif" border="0" alt="">',$text);
$text = str_replace(';)','<img src="images/icon_wink.gif" border="0" alt="">',$text);
$text = preg_replace("/\:o/i",'<img src="images/icon_redface.gif" border="0" alt="">',$text);
$text = preg_replace("/\:p/i",'<img src="images/icon_razz.gif" border="0" alt="">',$text);
$text = str_replace(':cool:','<img src="images/icon_cool.gif" border="0" alt="">',$text);
$text = str_replace(':rolleyes:','<img src="images/icon_rolleyes.gif" border="0" alt="">',$text);
$text = str_replace(':mad:','<img src="images/icon_mad.gif" border="0" alt="">',$text);
$text = str_replace(':eek:','<img src="images/icon_eek.gif" border="0" alt="">',$text);
$text = str_replace(':clap:','<img src="images/yelclap.gif" border="0" alt="">',$text);
$text = str_replace(':bonk:','<img src="images/bonk.gif" border="0" alt="">',$text);
$text = str_replace(':chased:','<img src="images/chased.gif" border="0" alt="">',$text);
$text = str_replace(':crazy:','<img src="images/crazy.gif" border="0" alt="">',$text);
$text = str_replace(':cry:','<img src="images/cry.gif" border="0" alt="">',$text);
$text = str_replace(':curse:','<img src="images/curse.gif" border="0" alt="">',$text);
$text = str_replace(':err:','<img src="images/errr.gif" border="0" alt="">',$text);
$text = str_replace(':livid:','<img src="images/livid.gif" border="0" alt="">',$text);
$text = str_replace(':rotflol:','<img src="images/rotflol.gif" border="0" alt="">',$text);
$text = str_replace(':love:','<img src="images/love.gif" border="0" alt="">',$text);
$text = str_replace(':nerd:','<img src="images/nerd.gif" border="0" alt="">',$text);
$text = str_replace(':nono:','<img src="images/nono.gif" border="0" alt="">',$text);
$text = str_replace(':smash:','<img src="images/smash.gif" border="0" alt="">',$text);
$text = str_replace(':thumbsup:','<img src="images/thumbup.gif" border="0" alt="">',$text);
$text = str_replace(':toast:','<img src="images/toast.gif" border="0" alt="">',$text);
$text = str_replace(':welcome:','<img src="images/welcome.gif" border="0" alt="">',$text);
$text = str_replace(':ylsuper:','<img src="images/ylsuper.gif" border="0" alt="">',$text);
return $text;
} // END processsmileys

function doDelete($pass,$num) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
if ($pass != $settings[apass]) {problem($lang_problem07);}
$lines=file($settings['logfile']);
unset($lines[$num]);
$lines=implode('',$lines);
$fp = fopen($settings['logfile'],'wb') or problem($lang_problem04a.$settings[logfile].$lang_problem04b);
fputs($fp,$lines);
fclose($fp);
?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p><b><? echo $lang_entry_removed; ?></b></p>
<p><a href="gbook.php?page=1"><? echo $lang_click_here; ?></a></p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END doDelete

function confirmDelete($num) {
global $settings;    //  link to  -  FMH
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<form action="gbook.php" method="POST"><input type="hidden" name="a" value="confirmdelete">
<input type="hidden" name="num" value="<?php echo($num); ?>">
<p><b><? echo $lang_enter_password; ?></b><br>
<input type="password" name="pass" size="20"></p>
<p><b><? echo $lang_want_to_delete; ?></b></p>
<p><input type="submit" value="<? echo $lang_delete; ?>"> | <a href="gbook.php"><? echo $lang_donot_delete; ?></a></p>
</form>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END confirmDelete

function check_mail_url()
{
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
$v = array('email' => '','url' => '');
$char = array('.','@');
$repl = array('&#46;','&#64;');

$v['email']=htmlspecialchars($_POST['email']);
if (strlen($v['email']) > 0 && !(preg_match("/([\w\-]+\@[\w\-]+\.[\w\-]+)/",$v['email']))) {$v['email']=$lang_invalid;}
$v['email']=str_replace($char,$repl,$v['email']);

if ($settings['use_url'])
{
	$v['url']=htmlspecialchars($_POST['url']);
	if ($v['url'] == 'http://' || $v['url'] == 'https://') {$v['url'] = '';}
	elseif (strlen($v['url']) > 0 && !(preg_match("/(http(s)?:\/\/+[\w\-]+\.[\w\-]+)/i",$v['url']))) {$v['url'] = $lang_invalid;}
}
elseif (!empty($_POST['url']))
{
	$_SESSION['block'] = 1;
	problem($lang_problem01,0);
}
else
{
	$v['url'] = '';
}

return $v;
} // END check_mail_url


function addEntry($name,$from,$email,$url,$comments,$isprivate="0") {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
	/* This part will help prevent multiple submissions */
    if ($settings['one_per_session'] && $_SESSION['add'])
    {
        problem($lang_problem08,0);
    }

$delimiter="\t";
$added=date ("F j, Y");

$comments_nosmileys=$comments;
$comments = str_replace("\r\n","<br>",$comments);
$comments = str_replace("\n","<br>",$comments);
$comments = str_replace("\r","<br>",$comments);
$comments = wordwrap($comments,$settings['max_word'],' ',1);
if ($settings['smileys'] == 1 && $_REQUEST['nosmileys'] != "Y") {$comments = processsmileys($comments);}

if ($settings['filter']) {
$comments = filter_bad_words($comments);
$name = filter_bad_words($name);
$from = filter_bad_words($from);
}

$addline = $name.$delimiter.$from.$delimiter.$email.$delimiter.$url.$delimiter.$comments.$delimiter.$added.$delimiter.$isprivate.$delimiter.'0'.$delimiter.$_SERVER['REMOTE_ADDR']."\n";

$fp = @fopen($settings['logfile'],'rb') or problem($lang_problem09a.$settings[logfile].$lang_problem09b);
$links = @fread($fp,filesize($settings['logfile']));
fclose($fp);
$addline .= $links;
$fp = fopen($settings['logfile'],'wb') or problem($lang_problem04a.$settings[logfile].$lang_problem04b);
fputs($fp,$addline);
fclose($fp);

if ($settings['notify'] == 1)
   {
    $char = array('.','@');
    $repl = array('&#46;','&#64;');
    $email = str_replace($repl,$char,$email);
    $message = $lang_message01a.$lang_skipline.$lang_skipline.$lang_name.$name.$lang_skipline.$lang_from.$from.$lang_skipline.$lang_email.$email.$lang_skipline.$lang_website.$website.$lang_skipline.$lang_skipline.$lang_message01b.$lang_skipline.$comments_nosmileys.$lang_skipline.$lang_skipline.$lang_message01c.$lang_skipline.$settings[gbook_url].$lang_skipline.$lang_skipline.$lang_message01d;

    mail("$settings[admin_email]",$lang_message01a,$message);
    }

/* Register this session variable */
$_SESSION['add']=1;

?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p><b><? echo $lang_entry_added; ?></b></p>
<p><a href="gbook.php?page=1"><? echo $lang_click_here; ?></a></p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<?php
printDownHTML();
exit();
} // END addEntry

function printSign($name='',$from='',$email='',$url='',$comments='',$nosmileys='',$isprivate='',$error='') {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
$url=$url ? $url : 'http://';
?>
<h3 align="center"><? echo $lang_sign_book; ?></h3>
<p><? echo $lang_required_bold; ?></p>
<form action="gbook.php" method="POST" name="form">
<input type="hidden" name="a" value="add">
<table class="entries" cellspacing="0" cellpadding="4" border="0">
<tr>
<td>

<?php
if ($error) {
        echo '<p align="center"><font color="#FF0000"><b>'.$error.'</b></font></p>';
}
?>

<table cellspacing="0" cellpadding="3" border="0">
<tr>
<td><b><? echo $lang_your_name; ?></b></td>
<td><input type="text" name="name" size="30" maxlength="30" value="<?php echo $name; ?>"></td>
</tr>
<tr>
<td><? echo $lang_your_location; ?></td>
<td><input type="text" name="from" size="30" maxlength="30" value="<?php echo $from; ?>"></td>
</tr>
<tr>
<td><? echo $lang_your_email; ?></td>
<td><input type="text" name="email" size="30" maxlength="50" value="<?php echo $email; ?>"></td>
</tr>
<?php
if ($settings['use_url']) {
	echo '
	<tr>
	<td>'.$lang_your_website.'</td>
	<td><input type="text" name="url" value="'.$url.'" size="40" maxlength="80"></td>
	</tr>
	';
}
?>
</table>
<p align="center"><b><? echo $lang_your_comments; ?></b><br>
<i><? echo $lang_no_url; ?></i><br>
<textarea name="comments" rows="9" cols="50"><?php echo $comments; ?></textarea>
<?php
if ($settings['smileys']) {
	echo '
	<br><a href="javascript:openSmiley()">'.$lang_insert_smiley.'</a>'.$lang_open_window.'<br>
	<input type="checkbox" name="nosmileys" value="Y" '.$nosmileys.'>'.$lang_disable_smiley;
}
?>
</p>
<?php
if ($settings['use_private']) {
	echo '
	<p align="center"><input type="checkbox" name="private" value="Y" '.$isprivate.'>'.$lang_make_private.'</p>
	';
}
if ($settings['autosubmit']==1) {
	echo '
	<p align="center"><img src="print_sec_img.php" width="100" height="20" alt="Security image" border="1"><br>
    '.$lang_enter_secnum.'<input type="text" name="mysecnum" size="10" maxlength="5"></p>
	';
} elseif ($settings['autosubmit']==2) {
	echo '
	<p align="center"><b>'.$_SESSION['secnum'].'</b><br>'.$lang_enter_secnum.'<input type="text" name="mysecnum" size="10" maxlength="5"></p>
	';
}
?>

<p align="center"><input type="submit" value="<? echo $lang_add_comments; ?>"></p>
</td>
</tr>
</table>
</form>
<?php
printDownHTML();

exit();
} // END printSign

function printEntries($lines,$start,$end) {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
$start=$start-1;
$end=$end-1;
$delimiter="\t";

for ($i=$start;$i<=$end;$i++) {
$lines[$i]=rtrim($lines[$i]);
list($name,$from,$email,$url,$comment,$added,$isprivate,$reply)=explode($delimiter,$lines[$i]);
echo '
<tr>
<td class="upper" width="35%"><b>'.$lang_submitted_by.'</b></td>
<td class="upper" width="65%"><b>'.$lang_comments.'</b></td>
</tr>
<tr>
<td valign="top" width="35%">'.$lang_name.'<b>'.$name.'</b><br>
';
if ($from)
{
	echo '<font class="smaller">'.$lang_from.$from.'</font><br>';
}
if ($settings['use_url'] && $url)
{
	echo '<font class="smaller">'.$lang_website.'</font> <a href="go.php?url='.$url.'" target="_blank" class="smaller">'.$url.'</a><br>';
}
if ($email)
{
	echo '<font class="smaller">'.$lang_email.'</font> <a href="mailto&#58;'.$email.'" target="_blank" class="smaller">'.$email.'</a>';
}

echo '
</td>
<td valign="top" width="65%">
';

	if (empty($isprivate) || empty($settings['use_private'])) {echo $comment;}
    else {
        echo '<p>&nbsp;</p>
        <p><i><a href="gbook.php?a=viewprivate&amp;num='.$i.'">'.$lang_private_post.'</a></i></p>';
    }

    if (!empty($reply)) {
        echo '<p><i><b>'.$lang_admin_reply.'</b> '.$reply.'</i>';
    }

echo '<hr>
<table border="0" width="100%" cellspacing="0" cellpadding="0">
<tr>
<td width="50%" align="left"><font class="smaller">'.$lang_added.$added.'</font></td>
<td width="50%" align="right">
<a href="gbook.php?a=delete&amp;num='.$i.'"><img src="images/delete.gif" width="14" height="14" border="0" alt="'.$lang_delete_entry.'" title="'.$lang_delete_entry.'"></a>
&nbsp;<a href="gbook.php?a=reply&amp;num='.$i.'"><img src="images/reply.gif" width="14" height="14" border="0" alt="'.$lang_reply_toEntry.'" title="'.$lang_reply_to_entry.'"></a>
&nbsp;<a href="gbook.php?a=viewIP&amp;num='.$i.'"><img src="images/ip.gif" width="14" height="14" border="0" alt="'.$lang_view_ip_address.'" title="'.$lang_view_ip_address.'"></a>
&nbsp;
</td>
</tr>
</table>

</td>
</tr>
';
}
} // END printEntries

function problem($myproblem,$backlink=1) {
global $settings;    //  link to  -  FMH
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
$html = '<p>&nbsp;</p>
<p>&nbsp;</p>
<p align="center"><b>'.$lang_error.'</b></p>
<p align="center">'.$myproblem.'</p>
<p>&nbsp;</p>
';

    if ($backlink) {
		$html .= '<p align="center"><a href="Javascript:history.go(-1)">'.$lang_back_to_previous.'</a></p>';
    }

$html .= '<p>&nbsp;</p> <p>&nbsp;</p>';

echo $html;

printDownHTML();
exit();
} // END problem

function printNoCache() {
header("Expires: Mon, 26 Jul 2000 05:00:00 GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");
} // END printNoCache


function printTopHTML() {
global $settings;
include('language/'.$settings['filter_lang'].'.php');   //  link to language file  -  FMH
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>'.$settings['gbook_title'].'</title>
<meta content="text/html; charset=windows-1250">
<link href="style.css" type="text/css" rel="stylesheet">
<script language="Javascript" type="text/javascript"><!--
function openSmiley() {
w=window.open("smileys.htm", "smileys", "fullscreen=no,toolbar=no,status=no,menubar=no,scrollbars=yes,resizable=yes,directories=no,location=no,width=300,height=300");
  if(!w.opener)
  {
  w.opener=self;
  }
}
//-->
</script>
</head>
<body>
';
include_once 'header.txt';
echo '<h3 align="center">'.$settings['gbook_title'].'</h3>
<p align="center"><a href="'.$settings['website_url'].'">'.$lang_back_to.$settings['website_title'].'</a>
| <a href="gbook.php">'.$lang_view_book.'</a>
| <a href="gbook.php?a=sign">'.$lang_sign_book.'</a></p>
<div align="center">
<center>
';
} // END printTopHTML

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

function printDownHTML() {
global $settings;

eval(gzinflate(base64_decode('DdFHkqNIAEDR43RVsFCBECTR0Qu8N0KAEjYTWOESlMJz+qkL/M
X75Zr2X6+zGao+ncuvLJ1Khv6vKPOxKL/+CLmmTNiJeV66n8RwbbonXaoYK2QjCkbOo4NeWHyrPKLoSu
4kFK2KbhQFkhZssDVNwijQkQjIuxL0TQzJ7mDOjy0+GL0b1H6Gdjc+WNfKYtB5VGMxRR7uwutepEI+nA
THoV1Iw2iWWWebaWDnLLXVjAzU04dPk4FrmnFuYw/L60GtEUksO+5tkfHFox9RwfauSLlHdsnemmflec
eBrDNDjptOtYZvG8T9a7f1921GSPT1z0+crCZJ59bsQKC0HV7vvCH6JnjqO1RVglxUsdrkdH9JsHCDRg
vgyYRWLTt+bLWY2vO8gAX3smB2Uz67cuUS10AeuTb3zVIKVg876KmOl7ks02aS9fNpNcJE/m/Gmnk4Rg
tMLqOzIuxXrgYcw9DpPpqXyZJ7eyoWW+VkoQ5yW3vnlUm1n72Iw5B0bWbpLnYjyvwde7WxmP3mevgMcc
k6Or89VY4W1VGt2xxvZewGdvj4vRuIAI9vZv3x+kbiH4tPdnsU8SJsnUkxaEqU00gskpFcgthdl6likh
46GgHBYCF9V0w308Pm7F6GVDhBhR+cW4rjIvCsi59cslEEh+5JndwGzLDNeLWHusXxdErJUB8vHwx1qp
vDu+0Ouly7WQnxBDFW6YwB1NVzDneJ5MkVNEtBVr71ExtbSnr7zINPaZBOk/eyLjrZMbBmz2b107aaLj
TpBlBf3qcDJvSEGqeOAcsXmPb8e0tNzpiBkbOvJQE/EaKxT5/APoK7Y6MbdB7Xj+Uzt2uHTwUxpRE7fB
1wtCaVQxmn1WOUQJmwGbzKP+5H3NvsbhTSMYziLNRlLgA2JMw0e54oYalqqGS2rZRfszFGVBh1GoVwpX
lTs06LL1vj/TTfsmzsbCU1b/eq5IX/ktFh7NRZB0vfPwWh0rdBCy6lI3U6KCvHZsGl8ljislaX7d+/P9
/f33//Bw==')));
}  // END printDownHTML

function gbook_input($in,$error=0) {
	$in = trim($in);
    if (strlen($in))
    {
        $in = htmlspecialchars($in);
    }
    elseif ($error)
    {
        problem($error);
    }
    return stripslashes($in);
} // END gbook_input()

function gbook_isNumber($in,$error=0) {
	$in = trim($in);
	if (preg_match("/\D/",$in) || $in=="")
    {
        if ($error)
        {
                problem($error);
        }
        else
        {
                return '0';
        }
    }
    return $in;
} // END gbook_isNumber()


function JunkMark($email,$url,$comments) {
	/*
        JunkMark(TM) SPAM filter
        v1.1 from 25th Jul 2006
        (c) Copyright 2006 Klemen Stirn. All rights reserved.

        The function returns a number between 0 and 100. Larger numbers mean
        more probability that the message is SPAM. Recommended limit is 60
        (block message if score is 60 or more)

        THIS CODE MAY ONLY BE USED IN THE "GBOOK" SCRIPT FROM PHPJUNKYARD.COM
        AND DERIVATE WORKS OF THE GBOOK SCRIPT.

        THIS CODE MUSTN'T BE USED IN ANY OTHER SCRIPT AND/OR REDISTRIBUTED
        IN ANY MEDIUM WITHOUT THE EXPRESS WRITTEN PERMISSION OF KLEMEN STIRN!
    */
eval(gzinflate(base64_decode('DZNFDuRYAgWP09XywkzqlRl+mtmbkTHTzHj6qRu8UMSrzqz/83
2bse6zvfqTZ1tFEf8rq2Iqqz//iGkqiweicF/P7hC3GqTelUdySPfHeI13QxgGdvpSnz3qLO2GhvdlVn
bQwuL+YckPB/dVAIVPUMOwrPs5WAPYQMHTT69bN1h10NySZhPj+SYmV4VkxrbYHopyof0kLFwIdSNGdn
fuakTcuYLjXPr4Fa9O+0yfxW70Rlt15CCVpZWmsDI3whUanYwFS+cwRjZslZabl2QXJd1bQfh6Xf0NS2
Ps++YRZKN9uqcUfBNg9p1aUdvaSbLmMOXkqvo5KqMtfP2SdPZJAByuYUJ/S35cGISMViztUp7JT0gFNw
NUMtgVOgoTsLTBAbeNMeU8nos3iMCPuUk41y3z7X7IJAkTtG9rMg88WFmo7nDhtHJhBCXNJh7fW2xRRS
KNwIfBclHF5utMvlL3A7pCBHQjnu5xt50pUY2nUT5CXVIac+g7f8ot62nfj4AuI8wTGFpA29+rfsZ7Eu
oqVF+BNmqSjsqnHptvHi8xWorSKR3K1Ru+0sQtq12l0wrgvoOCNmIjgehjmKCyAtkEYZtUebKVh4tYav
RObkS5058ThjpcbWVZeNmEzBUWVz96iZu8L7+/bxMkxKaEnoTzMfqLKy0snH44pXBa8HVwcbCXm+zb+R
LXg+ZwGLVP3yVzjTmDbo9u5WeHRcsIArCU1Nyrcxv+DWgLC03Gw92KqCHQXM9g6Vhscmr0Bj1isyB2qd
YEeGUfzv0KdrT0WBmBrc/Elqyvg8qpskK0S9gSTJh4qnkcpeTLxTjXJgPdwWGfUqEwaViQlsHCdSFPRQ
2M5oGxVkIdP/ciOsOLmoAgoId2xcQNkuCWkup06vbVOd4pYt+XtcONbZSVc3joUqfqbO/Rmofd+6WvKL
eiSUjPBuFyRPhtAaR2H6EH2OQ2abCgn8+valApzek4V1RGUJR36h8UHOyCwDfO/uCt3iVpmwv/gNDbSP
EE7lMyaqhMlSKZzrNLpYwLnv3NdNZPSeAgiRa2mDCzGBPJ6vUKe8SLrK3V9ACwe0bL4HvMR9mogm00pO
ntUAguDaDyVzTZyTBnrLRgPrjmZXCJPOF/w+vQ3r4QG9fCMWjipQx5JWVjJb4DaCUNgO0c/Ov2ye+bXA
4fRIRqCCwuGLM37RvY84LPNQRVsXy+kAHNjJ1iQq3Cox6ulg8GbDv6/Bw5vF/vhXU4tmRefnUGC90lDQ
WibGMu9Ulfw1N5jGTM+7uNRwmNLbU3Ei9C5LJ/soqS9V2XrtuC8y43hDbl43djx77wg9K3pCnQ/4qXba
86CDwPvYYjHPjXiCgMtk9FM8XpkcBGF0GYpIZx/i53Z9bSbr4MEnkayM8PyfdONmN8A0MHo7JxwkbJ8a
lwF2bvUlvhROou+4XUE2zXi5TObdUo9f6lKXKHLVzRtEll7TStSTItxErevRSWzHlVBC6S+5I8mLPjOS
fgn3DQfJa6qGhgNqxeJE398qugNWXMNHPJMU+n7Po3rNZ9n89A0wf4EDwtEJrfctDhZoAytc7vOHWOnx
3NeENhTErMKIuUR77r19/xCOP8so6vRp3I2iaWDqVLOlCvwCTLMira10fp0a8bZiYSo422YTq0nhF6Ki
ISOLLdlVHyZmItk5WcfFN8lhUdDpUgtT0eEfYOl+cvgGIl/Bng4oOMI2c7W8j9JrOEAHjWH+ueQU/jYE
4mQiw+l1t9JFkes4InIK52c55gtY7+MY6OGnYe7dxeptqqrecY8B6POX2UZXKwy9vKkEmG3y1SlG/DZw
wtaJqwwcnz8GI4gAddOkqYg06a0zPu4PoGX2LrFa4DRJcQyeB6FWdgdVb7/klQg9KroYr2WjuxjSSZf1
vi+Z/gbWZfvOa12DepKwjLKerAck5AiCw1EeR9f6nb/r2hUwQbijLM0bzEcfPSgQvt1UrfxFA0mvtSBj
Xx9TM8D1t0UHr+PS9DlwVgLMTXVBlNaaSo1B5BOrPWoRwDaq5ISyMeYxQcGEQGOkAsVKywm+kJBJ12Mf
QiNrgld/b0EA8dCqDnMZ76pXZa9VAs6oyS3PCNzPtuUzKoSWS8neMI5m8/kFelcQHvw9IwVXzIPOgZSU
UKrcxfOf5OUK0Vlq0yxWPiqv8tmEN/wgW5LXmoK21GlcaiQM54m9NP27QhdioavfywiWXiHvntp6qAjV
iq/B4Z/jINocecGezD98ULX56TBN+lTvo8aRiCqqquYcb+599///3v/w==')));

    return $myscore;
}

?>